#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

int main() {
    int thepipe[2], pid;
    char theText[] = "Hello there!\nThe text has gotten through the pipe!\n";

    pipe( thepipe );

    if( (pid = fork()) == 0 ) {
        int retVal = 0;
        /* We are the child */
        close( thepipe[0] );
        while( 1 ) {
            printf( "I wrote %d bytes to the pipe.\n", retVal );
            retVal = write( thepipe[1], theText, sizeof(theText) );
            sleep( 1 );
        }
        close( thepipe[1] );
        printf( "Finished writing the data!\n" );
    } else {
        /* We are the parent */
        int quota = 0;

        close( thepipe[1] );

        do {
            char byte;
            int retVal = read( thepipe[0], &byte, 1 );

            if( retVal == 1 ) {
                quota++;
                printf( "%c", byte );
            } else if( retVal == -1 ) {
                /* Some sorta error occurred. */
                break;
            } else if( retVal == 0 ) {
                /* The pipe has been closed at the other end. */
                break;
            }
        } while( quota < 200 );
        printf( "\n" );
        close( thepipe[0] );
        waitpid( pid, NULL, 0 );
    }
    return 0;
}
